﻿Imports SldWorks
Imports SwConst
Imports System.IO

Public Class SolidWorker

    Public Shared Sub CreatePart(partPath As String, customer As String, totalLength As Double, handleLength As Double, diameter1 As Double, diameter2 As Double)
        totalLength = totalLength / 1000
        handleLength = handleLength / 1000
        diameter1 = diameter1 / 1000
        diameter2 = diameter2 / 1000

        Dim swApp As SldWorks.SldWorks = CreateObject("SldWorks.Application.22")
        swApp.Visible = False
        Dim errors As Long
        Dim swModel As SldWorks.ModelDoc2 = swApp.OpenDoc6(partPath, swDocumentTypes_e.swDocPART,
            swOpenDocOptions_e.swOpenDocOptions_Silent, Nothing, errors, Nothing)

        If errors = 0 Then
            'Modify dimensions
            Dim swDim As SldWorks.Dimension

            'Total length
            swDim = swModel.Parameter("D3@Sketch1")
            swDim.SetSystemValue3(totalLength, swSetValueInConfiguration_e.swSetValue_InAllConfigurations, Nothing)

            'Handle length
            swDim = swModel.Parameter("D2@Sketch1")
            swDim.SetSystemValue3(handleLength, swSetValueInConfiguration_e.swSetValue_InAllConfigurations, Nothing)

            'Diameter 1
            swDim = swModel.Parameter("D1@Sketch3")
            swDim.SetSystemValue3(diameter1, swSetValueInConfiguration_e.swSetValue_InAllConfigurations, Nothing)

            'Diameter 2
            swDim = swModel.Parameter("D2@Sketch3")
            swDim.SetSystemValue3(diameter2, swSetValueInConfiguration_e.swSetValue_InAllConfigurations, Nothing)

            'Update
            swModel.EditRebuild3()

            'Save file
            swModel.Extension.SaveAs(Path.GetDirectoryName(partPath) + "\" + customer + Path.GetExtension(partPath), swSaveAsVersion_e.swSaveAsCurrentVersion, swSaveAsOptions_e.swSaveAsOptions_Silent, _
                Nothing, Nothing, Nothing)

            'Close SolidWorks
            swApp.ExitApp()
        Else
            MsgBox("Could not open SolidWorks part with error code " + errors)
        End If
    End Sub

End Class
